/*=====================================================================================
               Programa de teste de libsk_access_tcp.so -Modo 4
 Compilar com:
 #gcc -L(caminho para o pacote) -Wall -o mtcs mtcs.c -lsk_access_tcp -lsk_sgd
                    
   V1.0 - 10/12/2013
=====================================================================================*/
#include <stdlib.h>
#include <stdio.h>
#include <dlfcn.h>
#include <curses.h>
#include <string.h>
#include "sk_access_tcp.h"
#include "sk_sgd.h"

//-------------------------------------------------------------------------------------
//               Rotina que simula o acesso ao banco de dados
// Retorna preco do produto em função de seu código de barras
//-------------------------------------------------------------------------------------
#define FALSE 0
#define TRUE 1
#define DataBank "MTC.txt"       //Banco de dados txt

void Le_Produto_Banco(char *BarCode,  char *Descricao, char *Preco){
  
  if(Find_Bar(BarCode,DataBank)){
     Get_Description(Descricao);
     Get_Price(Preco);
  }else
     strcpy(Descricao, "Produto inexistente");
}
//-------------------------------------------------------------------------------------
//                                 Estado 1
// Le codigo de barras finalizado por enter enviado pelo MTC e armazena em State_String
// lParam contem o valor ascii dos digitos enviados
//-------------------------------------------------------------------------------------
void _cdecl State1(long W_param,long L_param)
{
    Get_State_String(L_param,-1,(char)0x0d);//Le string, espera Enter para finalizar
}
//-------------------------------------------------------------------------------------
//                                 Estado 2
//  Processa o codigo de barras recebido em State_String
//-------------------------------------------------------------------------------------
void _cdecl State2(long W_param,long L_param)
{
char _Descricao[40];
char _Preco[40];

   if(strcmp(State_String(NULL),"")) 
      Set_State(1,0);		  //Retorna se string vazia
   Le_Produto_Banco( State_String(NULL), _Descricao, _Preco);
   Clear_Disp();
   Disp(_Descricao);
   Clear_L2();
   Disp(_Preco);   
   Set_State(1,0);				//Muda para proximo estado imediatamente
}
//-------------------------------------------------------------------------------------
//                       Processa comunicacoes do cliente
//-------------------------------------------------------------------------------------
void _cdecl Comunic(TMessage *Msg)
{
  State_Proccess(Msg->LParam);
}
//-------------------------------------------------------------------------------------
//                 Registra estados e inicia maquina de estados
//-------------------------------------------------------------------------------------
void ConfigServer()
{
   Set_Port(250);		//Seleciona porta do servidor
   Start_Server(0,&Comunic);	//Ativa servidor
   Register_State(1 , (TProc)&State1);
   Register_State(2 , (TProc)&State2);
   Start_Machine();		//Ativa maquina de estados
}
/*=====================================================================================
                               Programa principal
=====================================================================================*/

int main(int argc, char **argv)
{
   printf("Inicio\n");
   Set_Single_thread();    //Ativa modo single thread 
   ConfigServer();
   do{
     ProccessMessages();   //Processa mensagens (Comunic)
     usleep(100000);
     //if(condicao) break; //Aborta o loop
   }while(TRUE);
   Stop_Machine();
   Free_Sk_Access();
}